(function ($, Drupal) {

  /**
   * Used by the CreateEntityFromTemplateForm form, this will submit the form when the submit button has the
   * entity-template-ui-trigger-submit class, the specific case this is needed for is when a builder does not have
   * parameters and the submission of the form needs to happen automatically without the user having to click a button
   * in a page where there are no inputs.
   */
  Drupal.behaviors.entity_template_ui_trigger_submit = {
    attach: function (context) {
      const button = $("input.entity-template-ui-trigger-submit", context);
      button.click();
      button.val('Running...');
    }
  };

})(jQuery, Drupal);
