<?php

namespace Drupal\entity_template_ui\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\entity_template\BlueprintStorageInterface;
use Drupal\entity_template\TemplateManager;
use Drupal\entity_template_ui\Form\AddTemplateForm;
use Symfony\Component\DependencyInjection\ContainerInterface;

class ChooseTemplateController extends ControllerBase {

  /**
   * @var \Drupal\entity_template\TemplateManager
   */
  protected $templateManager;

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('plugin.manager.entity_template.template')
    );
  }

  /**
   * ChooseTemplateController constructor.
   *
   * @param \Drupal\entity_template\TemplateManager $template_manager
   */
  public function __construct(TemplateManager $template_manager) {
    $this->templateManager = $template_manager;
  }

  /**
   * @param \Drupal\entity_template\BlueprintStorageInterface $blueprint_storage
   */
  public function build(BlueprintStorageInterface $blueprint_storage) {
    $definitions = $this->templateManager->getDefinitions();

    if (count($definitions) === 1) {
      return $this->formBuilder()->getForm(
        AddTemplateForm::class,
        $blueprint_storage,
        key($definitions)
      );
    }
    else {
      // @todo: Build.

      return [];
    }
  }
}
