<?php

namespace Drupal\entity_template_ui\Entity;

use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\Core\Entity\Routing\DefaultHtmlRouteProvider;
use Drupal\Core\StringTranslation\TranslatableMarkup;
use Drupal\entity_template_ui\Controller\TemplateBuilderDefaultBlueprintController;
use Symfony\Component\Routing\Route;

class TemplateBuilderHtmlRouteProvider extends DefaultHtmlRouteProvider {

  /**
   * {@inheritdoc}
   */
  public function getRoutes(EntityTypeInterface $entity_type) {
    $collection = parent::getRoutes($entity_type);

    if ($entity_type->hasLinkTemplate('edit-default-blueprint')) {
      $route = new Route($entity_type->getLinkTemplate('edit-default-blueprint'));
      $route
        ->setDefault('_controller', TemplateBuilderDefaultBlueprintController::class.'::editDefaultBlueprint')
        ->setDefault('_title_callback', TemplateBuilderDefaultBlueprintController::class.'::editDefaultBlueprintTitle')
        ->setRequirement('_entity_access', $entity_type->id().'.update')
        ->setOption('parameters', [
          $entity_type->id() => ['type' => 'entity:' . $entity_type->id()],
        ]);

      $collection->add('entity.'.$entity_type->id().'.edit_default_blueprint', $route);
    }

    return $collection;
  }
}
