<?php

namespace Drupal\entity_template_ui\Form;

use Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface;

trait TemplateUIHelperTrait {

  /**
   * @var \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface
   */
  protected $template;

  /**
   * @var \Drupal\entity_template_ui\Plugin\EntityTemplate\Template\TemplateUIFactoryInterface
   */
  protected $templateUiFactory;

  /**
   * Get the template UI factory;
   *
   * @return \Drupal\entity_template_ui\Plugin\EntityTemplate\Template\TemplateUIFactoryInterface
   */
  protected function templateUiFactory() {
    if (!$this->templateUiFactory) {
      $this->templateUiFactory = \Drupal::service('entity_template_ui.template_ui_factory');
    }

    return $this->templateUiFactory;
  }

  /**
   * Get the template.
   *
   * @return \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface
   */
  public function getTemplate(): TemplateInterface {
    return $this->template;
  }

  /**
   * Get the template ui
   *
   * @param \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface|NULL $template
   *
   * @return \Drupal\entity_template_ui\Plugin\EntityTemplate\Template\TemplateUIInterface
   * @throws \Drupal\Component\Plugin\Exception\InvalidPluginDefinitionException
   */
  public function getTemplateUi(TemplateInterface $template = NULL) {
    $template = $template ?: $this->getTemplate();

    return $this->templateUiFactory()->ui($template);
  }

}
