<?php

namespace Drupal\entity_template_ui;

use Drupal\Core\TypedData\DataDefinitionInterface;
use Drupal\typed_data\Widget\FormWidgetManager;

class TypedDataFormWidgetManager extends FormWidgetManager {

  /**
   * Get the widget for the given data definition.
   *
   * @param \Drupal\Core\TypedData\DataDefinitionInterface $typed_data
   *
   * @return \Drupal\typed_data\Widget\FormWidgetInterface
   * @throws \Drupal\Component\Plugin\Exception\PluginException
   */
  public function getFormWidget(DataDefinitionInterface $data_definition) {
    foreach ($this->getDefinitions() as $id => $definition) {
      if ($id === 'broken') {
        continue;
      }
      $widget = $this->createInstance($id);

      if ($widget->isApplicable($data_definition)) {
        return $widget;
      }
    }

    return $this->createInstance('broken');
  }

}
