<?php

namespace Drupal\entity_template;

use Drupal\Core\Plugin\Context\ContextInterface;

interface ContextAwareInterface {

  /**
   * @return \Drupal\Core\Plugin\Context\ContextInterface[]
   */
  public function getContexts($sample = FALSE);

  /**
   * Get the context
   *
   * @param $name
   *
   * @return \Drupal\Core\Plugin\Context\ContextInterface
   */
  public function getContext($name, $sample = FALSE);

  /**
   * Set the context
   *
   * @param $name
   * @param \Drupal\Core\Plugin\Context\ContextInterface $context
   *
   * @return static
   */
  public function setContext($name, ContextInterface $context);

  /**
   * Get all the context values.
   *
   * @return array
   */
  public function getContextValues($sample = FALSE);

  /**
   * Get a particular context value.
   *
   * @param $name
   *
   * @return mixed
   */
  public function getContextValue($name, $sample = FALSE);

  /**
   * Get all the context definition interfaces
   *
   * @return \Drupal\Core\Plugin\Context\ContextDefinitionInterface[]
   */
  public function getContextDefinitions();

  /**
   * Get a specific context definition.
   *
   * @param $name
   *
   * @return \Drupal\Core\Plugin\Context\ContextDefinitionInterface
   */
  public function getContextDefinition($name);

}
