<?php

namespace Drupal\entity_template\Plugin\EntityTemplate\Component;

use Drupal\Component\Plugin\ConfigurableInterface;
use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Plugin\PluginFormInterface;
use Drupal\entity_template\TemplateResult;

/**
 * Interface ComponentInterface
 *
 * @package Drupal\entity_template\Plugin\EntityTemplate\Component
 */
interface ComponentInterface extends PluginInspectionInterface, ConfigurableInterface, PluginFormInterface {

  /**
   * Get the label of this plugin.
   *
   * @return \Drupal\Component\Render\MarkupInterface|string
   */
  public function label();

  /**
   * Get the description of this plugin.
   *
   * @return \Drupal\Component\Render\MarkupInterface|string
   */
  public function description();

  /**
   * Apply this component to the entity.
   *
   * @param \Drupal\Core\Entity\EntityInterface $entity
   * @param \Drupal\entity_template\TemplateResult $result
   */
  public function apply(EntityInterface $entity, TemplateResult $result);

}
