<?php

namespace Drupal\entity_template\Plugin\EntityTemplate\Template;

interface SubTemplateInterface extends TemplateInterface {

  /**
   * Get the parent template.
   *
   * @return \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface
   */
  public function getParentTemplate() : ?TemplateInterface;

  /**
   * Get the root template.
   *
   * @return \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface
   */
  public function getRootTemplate();

  /**
   * Get the template that is providing the contexts.
   *
   * @return \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface
   */
  public function getContextProvidingTemplate();

  /**
   * Get the path to the template from the root.
   *
   * @return string
   */
  public function getPath();

}
