<?php

namespace Drupal\entity_template;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager;

class TemplateBlueprintProviderManager extends DefaultPluginManager  {

  /**
   * TemplateBuilderManager constructor.
   *
   * @param \Traversable $namespaces
   * @param \Drupal\Core\Cache\CacheBackendInterface $cache_backend
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct(
      'Plugin/EntityTemplate/BlueprintProvider',
      $namespaces,
      $module_handler, 'Drupal\entity_template\Plugin\EntityTemplate\BlueprintProvider\BlueprintProviderInterface',
      'Drupal\entity_template\Annotation\EntityTemplateBlueprintProvider'
    );
    $this->alterInfo('entity_template_blueprint_provider');
    $this->setCacheBackend($cache_backend, 'entity_template_blueprint_provider');
  }

}
